﻿using System.Web.Mvc;
using MvcApplication8.Models;

namespace MvcApplication8.Controllers
{
    public class HomeController : Controller
    {
        
        public ActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public ActionResult CreateTask()
        {
            return View(new TaskViewModel());
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult CreateTask(TaskViewModel model)
        {

            // DEMO - Validierung wird im Service/BLL ausgeführt

            if(string.IsNullOrWhiteSpace(model.Name))
                ModelState.AddModelError("Name", "Bitte geben Sie einen Namen an.");

            if(string.IsNullOrWhiteSpace(model.Text))
                ModelState.AddModelError("Text", "Bitte geben Sie einen Text an.");

            if (ModelState.IsValid)
                TempData["Success"] = "Task erfolgreich angelegt.";

            if(Request.IsAjaxRequest())
            {
                if(ModelState.IsValid)
                    return Json(new AjaxOperationResultInfo { Successfull = true, RedirectUrl = Url.Action("index") });
                return PartialView("CreateTaskForm", model);
            }

            if(ModelState.IsValid)
                return RedirectToAction("index");
            return View(model);

        }

    }
}
